org.apache.commons.lang3.concurrent

## Interface CircuitBreaker<T>

- Type Parameters:
    `T` - the type of the value monitored by this circuit breaker
  All Known Implementing Classes:
    AbstractCircuitBreaker, EventCountCircuitBreaker, ThresholdCircuitBreaker

      public interface CircuitBreaker<T>

  An interface describing a Circuit Breaker component.

  A circuit breaker can be used to protect an application against unreliable services or unexpected load. It typically monitors a specific resource. As long as this resource works as expected, it stays in state closed, meaning that the resource can be used. If problems are encountered when using the resource, the circuit breaker can switch into state open; then access to this resource is prohibited. Depending on a concrete implementation, it is possible that the circuit breaker switches back to state closed when the resource becomes available again.

  This interface defines a generic protocol of a circuit breaker component. It should be sufficiently generic to be applied to multiple different use cases.

  Since:
    3.5

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `checkState()` Checks the state of this circuit breaker and changes it if necessary.
    `void` | `close()` Closes this circuit breaker.
    `boolean` | `incrementAndCheckState(T increment)` Increments the monitored value and performs a check of the current state of this circuit breaker.
    `boolean` | `isClosed()` Returns the current closed state of this circuit breaker.
    `boolean` | `isOpen()` Returns the current open state of this circuit breaker.
    `void` | `open()` Opens this circuit breaker.

- - ### Method Detail

    - #### isOpen

          boolean isOpen()

      Returns the current open state of this circuit breaker. A return value of true means that the circuit breaker is currently open indicating a problem in the monitored sub system.
      Returns:
        the current open state of this circuit breaker

    - #### isClosed

          boolean isClosed()

      Returns the current closed state of this circuit breaker. A return value of true means that the circuit breaker is currently closed. This means that everything is okay with the monitored sub system.
      Returns:
        the current closed state of this circuit breaker

    - #### checkState

          boolean checkState()

      Checks the state of this circuit breaker and changes it if necessary. The return value indicates whether the circuit breaker is now in state `CLOSED`; a value of true typically means that the current operation can continue.
      Returns:
        true if the circuit breaker is now closed; false otherwise

    - #### close

          void close()

      Closes this circuit breaker. Its state is changed to closed. If this circuit breaker is already closed, this method has no effect.

    - #### open

          void open()

      Opens this circuit breaker. Its state is changed to open. Depending on a concrete implementation, it may close itself again if the monitored sub system becomes available. If this circuit breaker is already open, this method has no effect.

    - #### incrementAndCheckState

          boolean incrementAndCheckState(T increment)

      Increments the monitored value and performs a check of the current state of this circuit breaker. This method works like `checkState()`, but the monitored value is incremented before the state check is performed.
      Parameters:
        `increment` - value to increment in the monitored value of the circuit breaker
      Returns:
        true if the circuit breaker is now closed; false otherwise

Copyright © 2001–2018 The Apache Software Foundation. All rights reserved.